package ejblogin;

import java.util.Enumeration;
import java.util.Properties;
import java.util.logging.Logger;

import javax.naming.InitialContext;

import com.sun.appserv.security.AppservRealm;
import com.sun.enterprise.security.auth.realm.BadRealmException;
import com.sun.enterprise.security.auth.realm.IASRealm;
import com.sun.enterprise.security.auth.realm.InvalidOperationException;
import com.sun.enterprise.security.auth.realm.NoSuchRealmException;
import com.sun.enterprise.security.auth.realm.NoSuchUserException;

import ejblogin.LoginServiceRemote;

/**
 * 
 * @author kor
 * 
 */
public class EjbRealm extends AppservRealm {
  
  private final Logger LOG = Logger.getLogger(EjbRealm.class.getName());

  public final static String DEFAULT_LOGIN_SERVICE_JNDI_NAME = "ejb/login";
    
  @Override
  public String getAuthType() {
    return null;
  }

  @Override
  public Enumeration<String> getGroupNames(String name)
      throws InvalidOperationException, NoSuchUserException {
    return null;
  }

  public String[] authenticate(String login, String password) {

    LOG.info("Realm authenticate");
    String[] grpList = null;
    try {
      LoginServiceRemote loginService = (LoginServiceRemote) 
        InitialContext.doLookup(DEFAULT_LOGIN_SERVICE_JNDI_NAME);    
      grpList = loginService.login(login, password);
    } catch (Exception e) {
      throw new IllegalArgumentException(
          "Failed to authenticate in Realm : " + e.getMessage(), e);
    }
    
    return grpList;
  }

  @Override
  protected void init(Properties props) throws BadRealmException,
      NoSuchRealmException {
    String jaasCtx = props.getProperty(IASRealm.JAAS_CONTEXT_PARAM);
    this.setProperty(IASRealm.JAAS_CONTEXT_PARAM, jaasCtx);
    if (jaasCtx == null) {
      throw new BadRealmException("bad context");
    }
  }
}
